package com.sun.org.apache.xalan.internal.xsltc.dom;

import com.sun.org.apache.xml.internal.dtm.DTMAxisIterator;
import com.sun.org.apache.xalan.internal.xsltc.DOM;

public final class UnionIterator extends MultiValuedNodeHeapIterator
{
    private final DOM _dom;
    
    public UnionIterator(DOM dom) {
        this._dom = dom;
    }
    
    public UnionIterator addIterator(DTMAxisIterator iterator) {
        this.addHeapNode(new UnionIterator.LookAheadIterator(iterator));
        return this;
    }
    
    private final class LookAheadIterator extends MultiValuedNodeHeapIterator.HeapNode
    {
        public DTMAxisIterator iterator;
        
        public LookAheadIterator(DTMAxisIterator iterator) {
            this.iterator = iterator;
        }
        
        @Override
        public int step() {
            return this._node = this.iterator.next();
        }
        
        @Override
        public MultiValuedNodeHeapIterator.HeapNode cloneHeapNode() {
            UnionIterator.LookAheadIterator clone = (UnionIterator.LookAheadIterator)super.cloneHeapNode();
            clone.iterator = this.iterator.cloneIterator();
            return clone;
        }
        
        @Override
        public void setMark() {
            super.setMark();
            this.iterator.setMark();
        }
        
        @Override
        public void gotoMark() {
            super.gotoMark();
            this.iterator.gotoMark();
        }
        
        @Override
        public boolean isLessThan(MultiValuedNodeHeapIterator.HeapNode heapNode) {
            UnionIterator.LookAheadIterator comparand = (UnionIterator.LookAheadIterator)heapNode;
            return UnionIterator.this._dom.lessThan(this._node, heapNode._node);
        }
        
        @Override
        public MultiValuedNodeHeapIterator.HeapNode setStartNode(int node) {
            this.iterator.setStartNode(node);
            return this;
        }
        
        @Override
        public MultiValuedNodeHeapIterator.HeapNode reset() {
            this.iterator.reset();
            return this;
        }
    }
}
